using FluentValidation;
using CMSMicroservice.Protobuf.Protos.ProductGalleries;
namespace CMSMicroservice.Protobuf.Validator.ProductGalleries;

public class CreateNewProductGalleriesRequestValidator : AbstractValidator<CreateNewProductGalleriesRequest>
{
    public CreateNewProductGalleriesRequestValidator()
    {
        RuleFor(model => model.ProductImageId)
            .NotNull();
        RuleFor(model => model.ProductId)
            .NotNull();
    }
    public Func<object, string, Task<IEnumerable<string>>> ValidateValue => async (model, propertyName) =>
    {
        var result = await ValidateAsync(ValidationContext<CreateNewProductGalleriesRequest>.CreateWithOptions((CreateNewProductGalleriesRequest)model, x => x.IncludeProperties(propertyName)));
        if (result.IsValid)
            return Array.Empty<string>();
        return result.Errors.Select(e => e.ErrorMessage);
    };
}
